/*
 * echoh.c - Print qdisc/class hierarchy
 *
 * Written 2001 by Werner Almesberger
 * Copyright 2001 Network Robots
 * Distributed under the LGPL.
 */


#include <stdio.h>

#include "tccext.h"
#include "echoh.h"


static void indent(FILE *file,int level)
{
    while (level--) fprintf(file,"  ");
}


static void qdiscs(FILE *file,TCCEXT_QDISC *q,int level);


static void classes(FILE *file,TCCEXT_CLASS *c,int level)
{
    while (c) {
	indent(file,level);
	fprintf(file,"class %d\n",c->index);
	classes(file,c->classes,level+1);
	if (c->qdisc) qdiscs(file,c->qdisc,level+1);
	c = c->next;
    }
}


static void qdiscs(FILE *file,TCCEXT_QDISC *q,int level)
{
    indent(file,level);
    fprintf(file,"qdisc %d %s\n",q->index,q->type);
    classes(file,q->classes,level+1);
}


void echoh_blocks(FILE *file,TCCEXT_BLOCK *b)
{
   while (b) {
	fprintf(file,"%s %sgress\n",b->name,b->role == tbr_ingress ? "in" :
	  "e");
	qdiscs(file,b->qdiscs,1);
	b = b->next;
   }
}
